<template>
  <Dialog
    title="您当前查看的是敏感信息，需要二次验证您的身份！"
    v-model="dialogVisible"
    width="600"
  >
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="登录密码" prop="password">
        <el-input
          v-model="formData.password"
          placeholder="请输入登录密码"
          type="password"
          show-password
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { EmployeeApi, Employee } from '@/api/hr/employee'
import { InsuranceSchemeApi, InsuranceScheme } from '@/api/hr/insurancescheme'
import { SalaryTaxRuleApi, SalaryTaxRule } from '@/api/hr/salarytaxrule'
import { DICT_TYPE, getIntDictOptions } from '@/utils/dict'

/** 员工 表单 */
defineOptions({ name: 'EmployeeForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formData = ref({
  userId: undefined,
  password: undefined,
  type: undefined
})
const formRules = reactive({
  password: [{ required: true, message: '登录密码不能为空', trigger: 'blur' }]
})
const formRef = ref() // 表单 Ref
/** 打开弹窗 */
const open = async (id?: number, type?: String) => {
  dialogVisible.value = true
  resetForm()
  formData.value.userId = id
  // formData.value.type = type
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as Employee
    const res = await EmployeeApi.getEmployeePersonalInfo(data)
    if (res) {
      dialogVisible.value = false
      emit('success', res)
    }
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    userId: undefined,
    password: undefined,
    type: undefined
  }
  formRef.value?.resetFields()
}
</script>
